package com.tashow.cloud.systemapi.api.user;

import static com.tashow.cloud.systemapi.api.user.AdminUserApi.PREFIX;

import cn.hutool.core.convert.Convert;
import com.fhs.core.trans.anno.AutoTrans;
import com.tashow.cloud.common.pojo.CommonResult;
import com.tashow.cloud.common.trans.AutoTransable;
import com.tashow.cloud.common.util.collection.CollectionUtils;
import com.tashow.cloud.systemapi.api.user.dto.AdminUserRespDTO;
import com.tashow.cloud.systemapi.enums.ApiConstants;
import feign.FeignIgnore;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = ApiConstants.NAME) // TODO 芋艿：fallbackFactory =
/** RPC 服务 - 管理员用户 */
@AutoTrans(
    namespace = PREFIX,
    fields = {"nickname"})
public interface AdminUserApi extends AutoTransable<AdminUserRespDTO> {

  String PREFIX = ApiConstants.PREFIX + "/user";

  @GetMapping(PREFIX + "/get")
  /** 通过用户 ID 查询用户 */
  CommonResult<AdminUserRespDTO> getUser(@RequestParam("id") Long id);

  @GetMapping(PREFIX + "/list-by-subordinate")
  /** 通过用户 ID 查询用户下属 */
  CommonResult<List<AdminUserRespDTO>> getUserListBySubordinate(@RequestParam("id") Long id);

  @GetMapping(PREFIX + "/list")
  /** 通过用户 ID 查询用户们 */
  CommonResult<List<AdminUserRespDTO>> getUserList(@RequestParam("ids") Collection<Long> ids);

  @GetMapping(PREFIX + "/list-by-dept-id")
  /** 获得指定部门的用户数组 */
  CommonResult<List<AdminUserRespDTO>> getUserListByDeptIds(
      @RequestParam("deptIds") Collection<Long> deptIds);

  @GetMapping(PREFIX + "/list-by-post-id")
  /** 获得指定岗位的用户数组 */
  CommonResult<List<AdminUserRespDTO>> getUserListByPostIds(
      @RequestParam("postIds") Collection<Long> postIds);

  /**
   * 获得用户 Map
   *
   * @param ids 用户编号数组
   * @return 用户 Map
   */
  default Map<Long, AdminUserRespDTO> getUserMap(Collection<Long> ids) {
    List<AdminUserRespDTO> users = getUserList(ids).getCheckedData();
    return CollectionUtils.convertMap(users, AdminUserRespDTO::getId);
  }

  /**
   * 校验用户是否有效。如下情况，视为无效： 1. 用户编号不存在 2. 用户被禁用
   *
   * @param id 用户编号
   */
  default void validateUser(Long id) {
    validateUserList(Collections.singleton(id));
  }

  @GetMapping(PREFIX + "/valid")
  /** 校验用户们是否有效 */
  CommonResult<Boolean> validateUserList(@RequestParam("ids") Collection<Long> ids);

  @Override
  @FeignIgnore
  default List<AdminUserRespDTO> selectByIds(List<?> ids) {
    return getUserList(Convert.toList(Long.class, ids)).getCheckedData();
  }

  @Override
  @FeignIgnore
  default AdminUserRespDTO selectById(Object id) {
    return getUser(Convert.toLong(id)).getCheckedData();
  }
}
